//       1         2         3         4         5         6         7
// 4567890123456789012345678901234567890123456789012345678901234567890123456789

package mml;

import la.la.Value;
import la.maths.Vector;

import mml.Model;
// ----------------------------------------------------------------------------

/* Copyright (c) 2018 Lloyd Allison.

   Reference: 
     Lloyd Allison, "Coding Ockham's Razor", Springer, 2018.

   This file is free software: you can redistribute it and/or modify it
   under the terms of the GNU General Public License (GPL) as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This file is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this file. If not, see http://www.gnu.org/licenses/
 */
// ----------------------------------------------------------------------------

/** See {@link MML#Known Known} Model. Requires msg1=msg2=0, sp=triv. */
public class KnownClass extends Model
 {
   public KnownClass(double msg1, double msg2, Value sp)
    { super(msg1, msg2, sp);
      if( msg1 != 0 || msg2 != 0 || sp != triv )
         error( " not Known(0,0,())" );
    }//constructor

   /** For all data, d, pr(d)=1, nlPr(d)=0. */
   public double nlPr(Value d) { return 0; }

   /** For every data-set, ds, <NOBR>nlLH(ss=stats(ds)) = 0</NOBR>. */
   public double nlLH(Value ss) { return 0; }

   /** Return <NOBR>triv = stats(ds)</NOBR>. */
   public Value.Triv stats(Vector ds, int lo, int hi)
    { return Value.triv; }

   public Value.Triv stats(boolean add, Value ss0, Value ss1)
    { return Value.triv; }

 }//KnownClass, the Model

// (c) Lloyd Allison, 2012, Tues 3 December 2013. Licence is Gnu GPL.
